/*
 * Wrapping Functions
 * http://greasemonkey.mozdev.org/authoring.html
 */

if (typeof(GM_xmlhttpRequest) != 'function') {
	function GM_xmlhttpRequest(details) {
		var req = (function () {
			if (window.opera && window.opera.XMLHttpRequest) {
				return new opera.XMLHttpRequest()
			} else if (window.XMLHttpRequest) {
				return new XMLHttpRequest();
			} else if(window.ActiveXObject){
				try {
					return new ActiveXObject('Msxml2.XMLHTTP');
				} catch (e) {
					try {
						return new ActiveXObject('Microsoft.XMLHTTP');
					} catch (e2) {
						return null;
		 			}
		 		}
			}
			return null;
		})();
		try {
			req.onreadystatechange = function () {
				if (req.readyState == 4 && req.status == 200 && details.onload) {
					details.onload(req);
				}
			}
			req.open(details.method || 'GET', details.url, true);
			if (details.headers) {
				for (key in details.headers) {
					req.setRequestHeader(key, details.headers[key]);
				}
			}
			req.send(null);
		} catch (e) {
			if (details.onerror) details.onerror(req, e);
		}
	}
}

if (typeof(GM_setValue) != 'function' && typeof(GM_getValue) != 'function') {
	function GM_setValue(name, value) {
		document.cookie = [
			name, '=', escape(value),
			';expires=', (new Date(new Date() + 365 * 1000 * 60 * 60 * 24)).toGMTString()
		].join('');
	}
	function GM_getValue(name, value) {
		var r = new RegExp('/' + name + '=([^;]*)/'), m;
		if (m = document.cookie.match(r))
			return unescape(m[1]);
		return value;
	}
	function GM_delValue(name, value) {
		if (GM_getValue(name, false))
			document.cookie = name + '=;expires=Thu, 01-Jan-1970 00:00:01 GMT';
	}
} else {
	var GM_delValue = GM_setValue;
}

if (typeof(GM_addStyle) != 'function') {
	function GM_addStyle(css) {
		var head = document.getElementsByTagName('head');
		if (!!head) {
			var style = document.createElement('style');
			style.type = 'text/css';
			style.innerHTML = css;
			head[0].appendChild(style);
		}
	}
}

function addEvent(elm, type, func, capt) {
	if (!!elm.addEventListener) {
		elm.addEventListener(t, func, capt);
		return true;
	} else if (!!elm.attachEvent) {
		return elm.attachEvent('on' + type, func);
	} else {
		type = 'on' + type;
		var old = elm[type];
		elm[type] = (typeof elm[type] != 'function') ? func : function () { old(); func(); }
	}
}

    var TPTIME;
    var TPKEY;
    var apiLoading = false;
    var dicAPI = 'http://stepup.yahoo.co.jp/english/tpanel/tpget.php';

    function setup() {
        GM_xmlhttpRequest({
                method: 'GET',
                url: 'http://stepup.yahoo.co.jp/english/index.html',
                onload: function(res) {
                    var stepupRawHTML = new String(res.responseText);
                    var reg = stepupRawHTML.match(/var TPTIME='(.*?)';var TPKEY='(.*?)'/);
                    if(reg) {
                        TPTIME = reg[1];
                        TPKEY = reg[2];
                        GM_setValue('TPTIME', TPTIME);
                        GM_setValue('TPKEY', TPKEY);
                    }
                },
        });
    }

    function mouseCapture(e) {
        if(apiLoading == true) return;

        TPTIME = GM_getValue('TPTIME', 0);
        TPKEY = GM_getValue('TPKEY', 0);
        if(TPTIME == "0" || TPKEY == "0") {
            setup();
        }

        var selectedText = document.getSelection();
        if(selectedText.length > 0) {
            showDictionary(selectedText, e.pageX, e.pageY);
        } else {
            document.getElementById('en-translation-v1').style.display = 'none';
        }
    }

    function showDictionary(text, x, y) {
        var apiURL = dicAPI + '?q=' + text + '&rnd=' + Math.random() + '&time=' + TPTIME + '&key=' + TPKEY;
        apiLoading = true;
        GM_xmlhttpRequest({
            method: 'GET',
            url: apiURL,
            onload: function(res) {
            apiLoading = false;
            var dicXML = new String(res.responseText);
            dicXML.match(/<query>(.+)<\/query>/);       var tp_query = RegExp.$1;
            dicXML.match(/<mode>(.+)<\/mode>/);         var tp_mode = RegExp.$1;
            dicXML.match(/<psym>(.+)<\/psym>/);         var tp_psym = RegExp.$1;
            dicXML.match(/<content>(.+)<\/content>/);   var tp_content = RegExp.$1;

            if(tp_mode == "3") {
                GM_setValue('TPTIME',0);
                GM_setValue('TPKEY', 0);
                setup();
                showDictionary(text, x, y);
                return;           
            }

            document.getElementById('word-en-translation-v1').innerHTML = tp_query;
            document.getElementById('pron-en-translation-v1').innerHTML = tp_psym;

            tob = document.getElementById('list-en-translation-v1');
            while(tob.childNodes.length > 0) {
                tob.removeChild(tob.childNodes[0]);
            }
            tconarr = new Array;
            tconarr = tp_content.split("##SP##");
            for(var i=0; i<tconarr.length; i++) {
                toElem = document.createElement('li');
                toElem.style.listStyleImage = "none";
                toElem.style.listStyleType = "none";
                toElem.style.listStylePosition = "outside";
                toElem.innerHTML = tconarr[i];
                tob.appendChild(toElem);
            }

            document.getElementById('anc-en-translation-v1').href = 'http://dic.yahoo.co.jp/dsearch?dtype=1&p=' + tp_query;
            x -= 20;
            y += 10;
            dic = document.getElementById('en-translation-v1');
            dic.style.top = y + 'px';
            dic.style.left = x + 'px';
            dic.style.display = 'block';

            },
            onerror: function(res) { apiLoading = false; },
        });
    }

    function setupDicResultBox() {

        var i = 1;

// copy from http://img.stepup.yahoo.co.jp/english/tts/english_tts_01.js
oElmDiv = document.createElement('div');
oElmDiv.setAttribute("id", "en-translation-v" + i );
oElmDiv.style.cssText = "text-align:left; z-index:100;";			
oElmDl = document.createElement('dl');
oElmDl.style.marginBottom = "0px"; // add
oElmDt = document.createElement('dt');
oElmDt.setAttribute("lang", "en");
oElmDt.setAttribute("class", "word");
oElmDt.setAttribute("className", "word");
oElmDt.setAttribute("id", "word-en-translation-v" + i );
oElmDt.appendChild( document.createTextNode( "dummy" ) );
oElmDl.appendChild( oElmDt );
oElmDt = document.createElement('dt');
oElmDt.setAttribute("class", "pronounce");
oElmDt.setAttribute("className", "pronounce");
oElmDt.setAttribute("id", "pron-en-translation-v" + i );
oElmDt.appendChild( document.createTextNode( "dumprono" ) );
oElmDl.appendChild( oElmDt );
oElmDd = document.createElement('dd');
oElmDd.style.margin = "0px"; // add
oElmDd.style.padding = "0px"; // add
oElmUl = document.createElement('ul');
oElmUl.style.margin = "0px"; // add
oElmUl.style.padding = "0px"; // add
oElmUl.style.fontSize = "10pt"; // add;
oElmUl.setAttribute("id", "list-en-translation-v" + i );
oElmLi = document.createElement('li');
oElmLi.appendChild( document.createTextNode(" " ) );
oElmUl.appendChild( oElmLi );
oElmDd.appendChild( oElmUl );
oElmUl = document.createElement('ul');
oElmUl.style.margin = "0px"; // add
oElmUl.style.padding = "0px"; // add
oElmUl.setAttribute("class", "translate");
oElmUl.setAttribute("className", "translate");
oElmLi = document.createElement('li');
oElmLi.style.listStyleImage = "none"; // add
oElmLi.style.listStyleType = "none"; // add
oElmLi.style.listStylePosition = "outside"; // add
oElmA = document.createElement('a');
oElmA.setAttribute("id", "anc-en-translation-v" + i );
oElmA.setAttribute("target", "dic" );
oElmImg = document.createElement('img');
oElmImg.setAttribute("src", "http://i.yimg.jp/images/edu/school_renewal/en_transrate.gif" );
oElmImg.setAttribute("alt", "Yahoo!Dictionary");
oElmImg.setAttribute("width", "200");
oElmImg.setAttribute("height", "33");
oElmImg.setAttribute("border", "0"); // add
oElmA.appendChild( oElmImg );
oElmLi.appendChild( oElmA );
oElmUl.appendChild( oElmLi );
oElmDd.appendChild( oElmUl );
oElmDl.appendChild( oElmDd );
oElmDiv.appendChild( oElmDl );
document.body.appendChild( oElmDiv );

        oStyle = document.createElement('link');
        oStyle.type = 'text/css';
        oStyle.href = 'http://i.yimg.jp/images/edu/css2/english/en-function.css';
        oStyle.rel = 'stylesheet';
        document.body.appendChild(oStyle);
    }

    setupDicResultBox();
    window.addEventListener('mouseup', mouseCapture, false);


